package at.tugraz.kmi.medokyservice.fca.bl;

import java.util.HashSet;
import java.util.Set;

import at.tugraz.kmi.medokyservice.fca.FCAException;
import at.tugraz.kmi.medokyservice.fca.db.Database;
import at.tugraz.kmi.medokyservice.fca.db.domainmodel.Course;
import at.tugraz.kmi.medokyservice.fca.db.domainmodel.Domain;
import at.tugraz.kmi.medokyservice.fca.db.usermodel.User;

public abstract class Magic {
 

  public static User createUnnamedUsersAsNeeded(String externalUID) {
    return createUserIfNeeded(externalUID, null, null, false);
  }

  public static User createOrIdentifyUser(String externalUID, String name, String description) {
    return createUserIfNeeded(externalUID, name, description, true);
  }

  private static User createUserIfNeeded(String externalUID, String name, String description, boolean setInfo) {
    User u = Database.getInstance().getUserByExternalUID(externalUID);
    if (u == null) {
      u = new User(externalUID, name, description);
    } else {
      if (setInfo) {
        u.setName(name);
        u.setDescription(description);
      }
    }
    Database.getInstance().put(u, false);
    return u;
  }

  public static void setDomainAdmins(String externalCourseID, String[] courseAdminIDs) {
    Course c = Database.getInstance().getCourseByExternalID(externalCourseID);
    if (c == null)
      return;
    Set<User> owners = new HashSet<User>();
    for (String eUID : courseAdminIDs) {
      if (eUID != null)
        owners.add(createUnnamedUsersAsNeeded(eUID));
      else
        System.err.println("admin with ID null appeared in method setDomainAdmins");
    }
    for (Domain d : c.getDomains()) {
      d.setOwners(owners);
    }
  }
}
